with Interfaces; use Interfaces;

package body CORBA_Repository_Root_ValueMemberDef_Hash is

   P : constant array (0 .. 3) of Natural :=
     (2, 4, 8, 10);

   T1 : constant array (0 .. 3) of Unsigned_8 :=
     (32, 10, 7, 3);

   T2 : constant array (0 .. 3) of Unsigned_8 :=
     (31, 3, 9, 45);

   G : constant array (0 .. 46) of Unsigned_8 :=
     (0, 0, 8, 18, 0, 0, 9, 0, 0, 11, 22, 0, 22, 0, 0, 9, 20, 0, 13, 0, 0,
      17, 0, 0, 0, 0, 0, 0, 0, 13, 0, 20, 0, 9, 5, 1, 5, 0, 8, 7, 0, 14, 3,
      0, 1, 0, 7);

   function Hash (S : String) return Natural is
      F : constant Natural := S'First - 1;
      L : constant Natural := S'Length;
      F1, F2 : Natural := 0;
      J : Natural;
   begin
      for K in P'Range loop
         exit when L < P (K);
         J  := Character'Pos (S (P (K) + F));
         F1 := (F1 + Natural (T1 (K)) * J) mod 47;
         F2 := (F2 + Natural (T2 (K)) * J) mod 47;
      end loop;
      return (Natural (G (F1)) + Natural (G (F2))) mod 23;
   end Hash;

end CORBA_Repository_Root_ValueMemberDef_Hash;
